/*
    ChibiOS - Copyright (C) 2006..2016 Giovanni Di Sirio

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/

#include "ch.h"
#include "hal.h"
#include "ch_test.h"



static void gpt1callback(GPTDriver *gptp) {
  //(void)gptp;
  // Perform your action here
  palToggleLine(LINE_LED5_ORANGE);

}

/*
 * Application entry point.
 */
int main(void) {

  /*
   * System initializations.
   * - HAL initialization, this also initializes the configured device drivers
   *   and performs the board-specific initializations.
   * - Kernel initialization, the main() function becomes a thread and the
   *   RTOS is active.
   */
  halInit();
  chSysInit();

  /*
   * Activates the serial driver 1 using the driver default configuration.
   * PA9(TX) and PA10(RX) are routed to USART1.
   */
  sdStart(&SD1, NULL);
  //palSetPadMode(GPIOA, 9, PAL_MODE_ALTERNATE(7));
 // palSetPadMode(GPIOA, 10, PAL_MODE_ALTERNATE(7));



  /*
   * Normal main() thread activity, in this demo it does nothing except
   * sleeping in a loop and check the button state, when the button is
   * pressed the test procedure is launched.
   */


  static const GPTConfig gpt1cfg = {
    10000, // 10 KHz timer clock.
    gpt1callback, // No callback
    0, 0
  };


  gptStart(&GPTD1, &gpt1cfg);
  gptStartContinuousI(&GPTD1, 5000);


  int FAST_BLINK=0;
  while (true) {
    if (palReadPad(GPIOA, GPIOA_BUTTON)){
      if(FAST_BLINK==0){
        gptStartContinuousI(&GPTD1, 1000);
        FAST_BLINK=1;
      }else{
        gptStartContinuousI(&GPTD1, 5000);
        FAST_BLINK=0;
      }

    }

    chThdSleepMilliseconds(300);
  }
}
